﻿using System.Net.Sockets;

namespace ProjectAiroplane.Entities;
public class EntityAiroplane : Entityplane
{
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия бака
    /// </summary>
    public bool Toplivbak { get; private set; }
    /// <summary>
    /// Признак (опция) наличия радара
    /// </summary>
    public bool Radar { get; private set; }

    /// <summary>
    /// Инициализация полей класса 
    /// </summary>
    /// <param name="speed"></скорость>
    /// <param name="weight"></вес>
    /// <param name="bodyColor"></Основной цвет>
    /// <param name="additionalColor"></Дополнительный цвет>
    /// <param name="toplivbak"></ Признак наличия бака>
    /// <param name="radar"></Признак (опция) наличия радара>

    public EntityAiroplane(int speed, double weight, Color bodyColor, Color additionalColor, bool toplivbak, bool radar) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Toplivbak = toplivbak;
        Radar = radar;
    }

    /// <summary>
    /// установка доп. цвета
    /// </summary>
    /// <param name="color"></param>
    public void setAdditionalColor(Color color)
    {
        AdditionalColor = color;
    }

    /// <summary>
    /// Получение строк со значениями свойств объекта класса-сущности
    /// </summary>
    /// <returns></returns>
    public override string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityAiroplane), Speed.ToString(), Weight.ToString(), BodyColor.Name, AdditionalColor.Name, Toplivbak.ToString(), Radar.ToString() };
    }
    /// <summary>
    /// Создание объекта из массива строк
    /// </summary>
    /// <param name="strs"></param>
    /// <returns></returns>
    public static EntityAiroplane? CreateEntityAiroplane(string[] strs)
    {
        if (strs.Length != 7 || strs[0] != nameof(EntityAiroplane))
        {
            return null;
        }
        return new EntityAiroplane(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]), Color.FromName(strs[4]), Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
    }
}


